**    Last revision: March 30, 1995 at 16:11

/***
*
*   CellEdit.Prg by Harry Van Tassell 02/15/95 Watchung, NJ
*
*   Default TCBrowse EditCell Function
*
*   2-24-95 added oCtx:RecLock()/UnLock()
*
*   2-27-95 added code for frozen columns
*/

#include "FiveWin.ch"

Function EditCell( oLbx, nRowPix, nColPix )

   local nActualCol := oLbx:nAtCol( nColPix, .t. )
   local nAtCol := oLbx:nAtCol( nColPix )
   local nColumn := If((nActualCol <=  oLbx:nFreeze), nActualCol , nAtCol)
   local uVar := Eval(oLbx:aColumns[nColumn]:bData)   // get value
   local cPic := oLbx:aColumns[nColumn]:cPicture
   local cMsg := oLbx:aColumns[nColumn]:cMsg
   local bValid := oLbx:aColumns[nColumn]:bValid
   local cErr := oLbx:aColumns[nColumn]:cError
   local cHeading := oLbx:aColumns[nColumn]:cHeading
   local lNoGrayBar := oLbx:lNoGrayBar
   local bOldErr

   if oLbx:aColumns[nColumn]:lEdit

      oLbx:lNoGrayBar := .f. // make sure line is grayed while editing
      if oLbx:lEditCol( nColumn, @uVar, cPic, bValid , CLR_WHITE, CLR_RED, ;
              cMsg, cErr )
        bOldErr := ErrorBlock( { |oE| Break(oE) } )
        BEGIN SEQUENCE
          if oLbx:oCtx == nil .or. oLbx:oDbf != nil
            // if no context or if oDbf don't lock, just do it
            // if oDbf assumes programmer will apply lock before saveing
            // next only works with Field/Memory Blocks
            Eval(oLbx:aColumns[nColumn]:bData, uVar ) 
          else
            if oLbx:oCtx:RecLock()
              // next only works with Field/Memory Blocks
              Eval(oLbx:aColumns[nColumn]:bData, uVar ) 
              oLbx:oCtx:UnLock()
            endif
          endif
        RECOVER
          Alert("Write Error, Operation Cancelled")
          oLbx:oCtx:UnLock()
        END SEQUENCE
        ErrorBlock(bOldErr)
      endif
      oLbx:lNoGrayBar := lNoGrayBar
      oLbx:DrawSelect()
      // must set focus back to browse if editing was done by button
      oLbx:SetFocus()
   else
     MsgBeep()
     MsgInfo( "Editing '"+Ltrim(Rtrim(cHeading))+"' Not Allowed" )
   endif

return nil


